library AIOWDG;

{$R *.res}

uses
  Windows,
{$IFDEF VER130}  // Delphi 5
  SysUtils, Classes,
{$ELSE}         // anything other than Delphi 5, presumably XE2 or XE3
  System.SysUtils,
  System.Classes,
{$ENDIF}

  SetupDi in 'SetupDi.pas',
  WinUSB in 'WinUSB.pas',
  ContBufThreads in 'ContBufThreads.pas',
  TheseUtils in 'TheseUtils.pas',
  CoreExports in 'CoreExports.pas'
  ;



function VBGetNumCards: Integer; stdcall;
begin
  Result := GetNumCards;
end;

function VBQueryCardInfo(CardNum: Integer; pDeviceID, pBase: PLongWord; pNameSize: pLongWord; pName: PAnsiChar): LongWord; stdcall;
begin
  Result := QueryCardInfo(CardNum, pDeviceID, pBase, pNameSize, pName);
end;

function VBQueryCardID(CardNum: Integer; pDeviceID: PLongWord): LongWord; stdcall;
begin
  Result := QueryCardID(CardNum, pDeviceID);
end;

function VBQueryCardName(CardNum: Integer; pNameSize: pLongWord; pName: PAnsiChar): LongWord; stdcall;
begin
  Result := QueryCardName(CardNum, pNameSize, pName);
end;

function VBQuerySerialNumber(CardNum: Integer; var pSerialNumber: Int64): LongWord; stdcall;
begin
  Result := QuerySerialNumber(CardNum, pSerialNumber);
end;

function VBAIOWDG_CloseDevice(CardNum: Integer): LongWord; stdcall;
begin
  Result := AIOWDG_CloseDevice(CardNum);
end;



function VBGetDeviceBySerialNumber(const pSerialNumber: Int64): Integer; stdcall;
begin
  Result := GetDeviceBySerialNumber(pSerialNumber);
end;

function VBGetDeviceByEEPROMByte(Data: Byte): Integer; stdcall;
begin
  Result := GetDeviceByEEPROMByte(Data);
end;

function VBGetDeviceByEEPROMData(StartAddress, DataSize: LongWord; pData: PByte): Integer; stdcall;
begin
  Result := GetDeviceByEEPROMData(StartAddress, DataSize, pData);
end;

function VBCustomEEPROMRead(CardNum: Integer; StartAddress: LongWord; var DataSize: LongWord; Data: Pointer): LongWord; stdcall;
begin
  Result := CustomEEPROMRead(CardNum, StartAddress, DataSize, Data);
end;

function VBCustomEEPROMWrite(CardNum: Integer; StartAddress: LongWord; DataSize: LongWord; Data: Pointer): LongWord; stdcall;
begin
  Result := CustomEEPROMWrite(CardNum, StartAddress, DataSize, Data);
end;



function VBWaitForWDG(CardNum: Integer): LongWord; stdcall;
begin
  Result := WaitForWDG(CardNum);
end;

function VBAbortWDGRequest(CardNum: Integer): LongWord; stdcall;
begin
  Result := AbortWDGRequest(CardNum);
end;



function VBWaitForCOS(CardNum: Integer; pDIData: PByte): LongWord; stdcall;
begin
  Result := WaitForCOS(CardNum, pDIData);
end;

function VBWaitForCOSMulti(CardNum: Integer; pTimestamp: PLongInt; DISize: LongInt; pDIData: PByte; pAIData: PDouble): LongWord; stdcall;
begin
  Result := WaitForCOSMulti(CardNum, pTimestamp, DISize, pDIData, pAIData);
end;

function VBAbortCOSRequest(CardNum: Integer): LongWord; stdcall;
begin
  Result := AbortCOSRequest(CardNum);
end;



function VBReadTimestamp(CardNum: Integer; pTimestamp: PWord): LongWord; stdcall;
begin
  Result := ReadTimestamp(CardNum, pTimestamp);
end;



function VBWDGInit(CardNum: Integer): LongWord; stdcall;
begin
  Result := WDGInit(CardNum);
end;

function VBWDGSetTimeout(CardNum: Integer; var pMilliseconds: Double): LongWord; stdcall;
begin
  Result := WDGSetTimeout(CardNum, pMilliseconds);
end;

function VBWDGSetResetDuration(CardNum: Integer; var pMilliseconds: Double): LongWord; stdcall;
begin
  Result := WDGSetResetDuration(CardNum, pMilliseconds);
end;

function VBWDGPet(CardNum: Integer): LongWord; stdcall;
begin
  Result := WDGPet(CardNum);
end;

function VBWDGReadTemp(CardNum: Integer; out TempF: Double): LongWord; stdcall;
begin
  Result := WDGReadTemp(CardNum, TempF);
end;

function VBWDGReadStatus(CardNum: Integer; out StatusByte: LongWord): LongWord; stdcall;
begin
  Result := WDGReadStatus(CardNum, StatusByte);
end;

function VBWDGStart(CardNum: Integer): LongWord; stdcall;
begin
  Result := WDGStart(CardNum);
end;

function VBWDGStop(CardNum: Integer): LongWord; stdcall;
begin
  Result := WDGStop(CardNum);
end;

function VBWDGHandleIRQ(CardNum: Integer; Action: LongWord): LongWord; stdcall;
begin
  Result := WDGHandleIRQ(CardNum, Action);
end;

function VBEmergencyReboot(): LongWord; stdcall;
begin
  Result := EmergencyReboot;
end;

function VBDI_ReadAll(CardNum: Integer; pDIData: PByte): LongWord; stdcall;
begin
  Result := DI_ReadAll(CardNum, pDIData);
end;

function VBDI_Read1(CardNum: Integer; BitIndex: Byte; pBitValue: PLongBool): LongWord; stdcall;
begin
  Result := DI_Read1(CardNum, BitIndex, pBitValue);
end;

function VBDI_ReadLatched(CardNum: Integer; pDIRisen, pDIFallen: PByte): LongWord; stdcall;
begin
  Result := DI_ReadLatched(CardNum, pDIRisen, pDIFallen);
end;

function VBDI_PeekAll(CardNum: Integer; pDIData: PByte): LongWord; stdcall;
begin
  Result := DI_PeekAll(CardNum, pDIData);
end;

function VBDI_Peek1(CardNum: Integer; BitIndex: Byte; pBitValue: PLongBool): LongWord; stdcall;
begin
  Result := DI_Peek1(CardNum, BitIndex, pBitValue);
end;

function VBDI_SetDebounceAll(CardNum: Integer; TimeMS: Byte): LongWord; stdcall;
begin
  Result := DI_SetDebounceAll(CardNum, TimeMS);
end;

function VBDI_SetDebounce1(CardNum: Integer; BitIndex: Byte; TimeMS: Byte): LongWord; stdcall;
begin
  Result := DI_SetDebounce1(CardNum, BitIndex, TimeMS);
end;

function VBDI_SetDebounceSome(CardNum: Integer; BitMask: Byte; TimeMS: Byte): LongWord; stdcall;
begin
  Result := DI_SetDebounceSome(CardNum, BitMask, TimeMS);
end;

function VBDO_WriteAll(CardNum: Integer; DOData: Byte): LongWord; stdcall;
begin
  Result := DO_WriteAll(CardNum, DOData);
end;

function VBDO_Write1(CardNum: Integer; BitIndex: Byte; BitValue: LongBool): LongWord; stdcall;
begin
  Result := DO_Write1(CardNum, BitIndex, BitValue);
end;

function VBAI_ReadAll(CardNum: Integer; pAIData: PDouble): LongWord; stdcall;
begin
  Result := AI_ReadAll(CardNum, pAIData);
end;

function VBAI_Read1(CardNum: Integer; ChannelIndex: Byte; pAIData: PDouble): LongWord; stdcall;
begin
  Result := AI_Read1(CardNum, ChannelIndex, pAIData);
end;



function VBRelInPortB(CardNum, Offset: LongWord): Word; stdcall;
begin
  Result := RelInPortB(CardNum, Offset);
end;

function VBRelOutPortB(CardNum, Offset: LongWord; Value: Byte): Word; stdcall;
begin
  Result := RelOutPortB(CardNum, Offset, Value);
end;



function VBGenericVendorRead(CardNum: Integer; Request: Byte; Value, Index: Word; var DataSize: LongWord; pData: Pointer): LongWord; stdcall;
begin
  Result := GenericVendorRead(CardNum, Request, Value, Index, DataSize, pData);
end;

function VBGenericVendorWrite(CardNum: Integer; Request: Byte; Value, Index: Word; DataSize: LongWord; pData: Pointer): LongWord; stdcall;
begin
  Result := GenericVendorWrite(CardNum, Request, Value, Index, DataSize, pData);
end;

function VBAWU_GenericBulkIn(CardNum: Integer; PipeID: LongWord; pData: Pointer; DataSize: LongWord; var BytesRead: LongWord): LongWord; stdcall;
begin
  Result := AWU_GenericBulkIn(CardNum, PipeID, pData, DataSize, BytesRead);
end;

function VBAWU_GenericBulkOut(CardNum: Integer; PipeID: LongWord; pData: Pointer; DataSize: LongWord; var BytesWritten: LongWord): LongWord; stdcall;
begin
  Result := AWU_GenericBulkOut(CardNum, PipeID, pData, DataSize, BytesWritten);
end;

function VBAIOWDG_ResetChip(CardNum: Integer): LongWord; cdecl;
begin
  Result := AIOWDG_ResetChip(CardNum);
end;





exports
  //These may be pruned; they're for indev compatibility, but they never left here, so we don't need to worry about them being in customer code.
    AbortWDGRequest name 'AbortRequest'      , AbortWDGRequest                        name '_AbortRequest'                             , VBAbortWDGRequest name 'VBAbortRequest'
  , WaitForWDG name 'WaitForIRQ'             , WaitForWDG                             name '_WaitForIRQ'                               , VBWaitForWDG name 'VBWaitForIRQ'



  //Fixed indices from here on down.

  , ReadTimestamp                            , ReadTimestamp                          name '_ReadTimestamp'                            , VBReadTimestamp

  , AbortCOSRequest                          , AbortCOSRequest                        name '_AbortCOSRequest'                          , VBAbortCOSRequest
  , WaitForCOSMulti                          , WaitForCOSMulti                        name '_WaitForCOSMulti'                          , VBWaitForCOSMulti
  , WaitForCOS                               , WaitForCOS                             name '_WaitForCOS'                               , VBWaitForCOS

  , AI_ReadAll                               , AI_ReadAll                             name '_AI_ReadAll'                               , VBAI_ReadAll
  , AI_Read1                                 , AI_Read1                               name '_AI_Read1'                                 , VBAI_Read1

  , DI_ReadAll                               , DI_ReadAll                             name '_DI_ReadAll'                               , VBDI_ReadAll
  , DI_Read1                                 , DI_Read1                               name '_DI_Read1'                                 , VBDI_Read1
  , DI_ReadLatched                           , DI_ReadLatched                         name '_DI_ReadLatched'                           , VBDI_ReadLatched
  , DI_PeekAll                               , DI_PeekAll                             name '_DI_PeekAll'                               , VBDI_PeekAll
  , DI_Peek1                                 , DI_Peek1                               name '_DI_Peek1'                                 , VBDI_Peek1
  , DI_SetDebounceAll                        , DI_SetDebounceAll                      name '_DI_SetDebounceAll'                        , VBDI_SetDebounceAll
  , DI_SetDebounce1                          , DI_SetDebounce1                        name '_DI_SetDebounce1'                          , VBDI_SetDebounce1
  , DI_SetDebounceSome                       , DI_SetDebounceSome                     name '_DI_SetDebounceSome'                       , VBDI_SetDebounceSome
  , DO_WriteAll                              , DO_WriteAll                            name '_DO_WriteAll'                              , VBDO_WriteAll
  , DO_Write1                                , DO_Write1                              name '_DO_Write1'                                , VBDO_Write1

  , AIOWDG_ResetChip                         , AIOWDG_ResetChip                       name '_AIOWDG_ResetChip'                         , VBAIOWDG_ResetChip
  , AWU_GenericBulkOut                       , AWU_GenericBulkOut                     name '_AWU_GenericBulkOut'                       , VBAWU_GenericBulkOut
  , AWU_GenericBulkIn                        , AWU_GenericBulkIn                      name '_AWU_GenericBulkIn'                        , VBAWU_GenericBulkIn
  , GenericVendorWrite                       , GenericVendorWrite                     name '_GenericVendorWrite'                       , VBGenericVendorWrite
  , GenericVendorRead                        , GenericVendorRead                      name '_GenericVendorRead'                        , VBGenericVendorRead

  , EmergencyReboot                          , EmergencyReboot                        name '_EmergencyReboot'                          , VBEmergencyReboot
  , WDGHandleIRQ                             , WDGHandleIRQ                           name '_WDGHandleIRQ'                             , VBWDGHandleIRQ
  , WDGStop                                  , WDGStop                                name '_WDGStop'                                  , VBWDGStop
  , WDGStart                                 , WDGStart                               name '_WDGStart'                                 , VBWDGStart
  , WDGReadStatus                            , WDGReadStatus                          name '_WDGReadStatus'                            , VBWDGReadStatus
  , WDGReadTemp                              , WDGReadTemp                            name '_WDGReadTemp'                              , VBWDGReadTemp
  , WDGPet                                   , WDGPet                                 name '_WDGPet'                                   , VBWDGPet
  , WDGSetResetDuration                      , WDGSetResetDuration                    name '_WDGSetResetDuration'                      , VBWDGSetResetDuration
  , WDGSetTimeout                            , WDGSetTimeout                          name '_WDGSetTimeout'                            , VBWDGSetTimeout
  , WDGInit                                  , WDGInit                                name '_WDGInit'                                  , VBWDGInit

  , AbortWDGRequest                          , AbortWDGRequest                        name '_AbortWDGRequest'                          , VBAbortWDGRequest
  , WaitForWDG                               , WaitForWDG                             name '_WaitForWDG'                               , VBWaitForWDG

  , CustomEEPROMWrite                        , CustomEEPROMWrite                      name '_CustomEEPROMWrite'                        , VBCustomEEPROMWrite
  , CustomEEPROMRead                         , CustomEEPROMRead                       name '_CustomEEPROMRead'                         , VBCustomEEPROMRead
  , GetDeviceByEEPROMData                    , GetDeviceByEEPROMData                  name '_GetDeviceByEEPROMData'                    , VBGetDeviceByEEPROMData
  , GetDeviceByEEPROMByte                    , GetDeviceByEEPROMByte                  name '_GetDeviceByEEPROMByte'                    , VBGetDeviceByEEPROMByte
  , GetDeviceBySerialNumber                  , GetDeviceBySerialNumber                name '_GetDeviceBySerialNumber'                  , VBGetDeviceBySerialNumber

  , AIOWDG_CloseDevice                       , AIOWDG_CloseDevice                     name '_AIOWDG_CloseDevice'                       , VBAIOWDG_CloseDevice
  , QuerySerialNumber                        , QuerySerialNumber                      name '_QuerySerialNumber'                        , VBQuerySerialNumber
  , QueryCardName                            , QueryCardName                          name '_QueryCardName'                            , VBQueryCardName
  , QueryCardID                              , QueryCardID                            name '_QueryCardID'                              , VBQueryCardID
  , QueryCardInfo                            , QueryCardInfo                          name '_QueryCardInfo'                            , VBQueryCardInfo
  , GetNumCards                              , GetNumCards                            name '_GetNumCards'                              , VBGetNumCards
  ;



begin
  LoadDriverLinks;
end.
